/*Acts as communication layer for the entire App and Token Handling*/
/*global angular*/
(function () {
    'use strict';

    function dataService($http, $rootScope, $q, $sessionStorage,$log) {
    	var basePath = 'http://localhost:8080/iTAW/';
    //   var basePath = uiConfig.paths.basePath;
        var service = {};
      //  service.authenticate = authenticate;
        service.restCall = restCall;
     //   service.SetCredentials = SetCredentials;
     //   service.ClearCredentials = ClearCredentials;
      //  service.tokenCall = tokenCall;
     //   service.fileApi = fileApi;
    //    service.fileMultipleApi = fileMultipleApi;
    //    service.restCallJSON = restCallJSON;
        return service;

        /*Write log to console */
        function writeServiceLog(url, method) {
            $log.debug('Accessing ' + url + ' with method ' + method + ' @ ' + new Date() + '\n');
        }
        
        /* Auth Handler */
        function authenticate(url, method, payload, headers, transform) {
            writeServiceLog(url, method);
            return $http({
                method: method,
                url: basePath + url,
                data: payload,
                headers: headers || {},
                transformRequest: [function (payload) {
                    if (transform == "transform") {
                        var str = [];
                        for (var p in payload)
                            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(payload[p]));
                        return str.join("&");
                    }
                    else {
                        return "";
                    }
                }].concat($http.defaults.transformRequest)
            }).then(handleSuccess, handleError);
        }

        /* Generic Rest Handler */
        function restCall(url, method, payload) {
            // var newPayload = getModifiedPayload(payload,url);
            writeServiceLog(url, method);
            var regionId = ($sessionStorage.get('region') || {});
            console.log('regionId'+regionId);
            var newPayload = payload;
            return $http({
                method: method,
                url: basePath + url,
                data: newPayload,
                cache: false,
                headers: {
                    "Content-Type": "application/json",
                    "Accept": "application/json",
                    "Region": regionId
                }
            }).then(handleSuccess, handleError);
        }

        function restCallJSON(url, method, payload) {
            return $http({
                method: method,
                url: url,
                data: payload,
                headers: {
                    "Content-Type": "application/json",
                    "Accept": "application/json"
                }
            }).then(handleSuccess, handleError);
        }

        function tokenCall() {
            if (uiConfig.generateRefreshToken) {
            var globals = $sessionStorage.get('globals');
            var tokenData = { "client_id": globals.currentUser.clientId, "refresh_token": globals.currentUser.refresh_token, "grant_type": "refresh_token" };
            return $http({
                method: "POST",
                url: basePath + uiConfig.paths.endPoints.oauth,
                data: tokenData,
                headers: {
                    "Content-Type": "application/x-www-form-urlencoded",
                    "Accept": "application/json"
                },
                transformRequest: [function (tokenData) {
                    var str = [];
                    for (var p in tokenData)
                        str.push(encodeURIComponent(p) + "=" + encodeURIComponent(tokenData[p]));
                    return str.join("&");
                }].concat($http.defaults.transformRequest)
            }).then(handleSuccessToken, handleErrorToken);

            } else {
                return true;
            }
        }       

        function fileApi(url, method, payload, file) {
            // var newPayload = getModifiedPayload(payload,url);
            var regionId = ($sessionStorage.get('region') || {});
            var newPayload = payload;
            return $http({
                method: method,
                url: basePath + url,
                data: { model: newPayload, files: file },
                headers: {
                    "Content-Type": undefined,
                    "Region": regionId
                    },
                //This method will allow us to change how the data is sent up to the server
                // for which we'll need to encapsulate the model data in 'FormData'
                transformRequest: [function (data) {
                    var formData = new FormData();
                    formData.append("model", angular.toJson(data.model));
                    formData.append("files", data.files);
                    return formData;
                }].concat($http.defaults.transformRequest)
            }).then(handleSuccess, handleError);
        }

        function fileMultipleApi(url, method, formData) {
            var regionId = ($sessionStorage.get('region') || {});
            return $http({
                method: method,
                url: basePath + url,
                data: formData,
                headers: {
                    "Content-Type": undefined,
                    "Region": regionId
                },
            }).then(handleSuccess, handleError);
        }
        
        /* Set credentials methods on Initial Login */
        function SetCredentials(username, clientId, role, token, refresh_token, access, region) {
            var loginStatus = true;
            var deferred = $q.defer();
            $rootScope.globals = {
                currentUser: {
                    username: username,
                    clientId: clientId,
                    role: role,
                    token: token,
                    refresh_token: refresh_token,
                    moduleaccess: access,
                    regionId: region.Id
                }
            };
            $sessionStorage.put('globals', $rootScope.globals);
            $sessionStorage.put('region', region.Id);
            $sessionStorage.put('regionName', region.RegionName);
            $rootScope.$broadcast("userSet");
            $http.defaults.headers.common['Authorization'] = 'Bearer ' + token;
            deferred.resolve({
                status: "User successfully set"
            });
            return deferred.promise;
        }

        function ClearCredentials() {
            var deferred = $q.defer();
            $rootScope.globals = {};
            // console.clear();
            $sessionStorage.remove('carrierData');
            $sessionStorage.remove('globals');
            $sessionStorage.remove('region');
            $sessionStorage.remove('regionName');
            $http.defaults.headers.common.Authorization = 'Basic ';
            deferred.resolve({
                status: "Successfully logged out"
            });
            return deferred.promise;
        }

      /*  function pruneEmpty(obj) {
            return function prune(current) {
                _.forOwn(current, function (value, key) {
                    if (_.isUndefined(value) || _.isNull(value) || _.isNaN(value) ||
                        (_.isString(value) && _.isEmpty(value)) ||
                        (_.isObject(value) && _.isEmpty(prune(value)))) {

                        delete current[key];
                    }
                });
                // remove any leftover undefined values from the delete 
                // operation on an array
                if (_.isArray(current)) _.pull(current, undefined);

                return current;

            }(_.cloneDeep(obj));  // Do not modify the original object, create a clone instead
        }*/

        function getModifiedPayload(payload, url) {
            var modPayload;
            for (var prop in uiConfig.paths.endPoints) {
                if (uiConfig.paths.endPoints.hasOwnProperty(prop)) {
                    if (uiConfig.paths.endPoints[prop] === url) {
                        if ($.inArray(prop, uiConfig.paths.nullExceptions) === -1) {
                            modPayload = pruneEmpty(payload);
                            return modPayload;
                        } else {
                            modPayload = payload;
                            return modPayload;
                        }
                    }
                }
            }
        }

        /**Generic Success and Error Handlers for service calls**/

        function handleSuccess(response) {
            writeServiceLog(JSON.stringify(response.data), "");
            return (response.data);
        }

        function handleError(response) {
            writeServiceLog(JSON.stringify(response.data), "");
            if (response.data == undefined || response.data == null) {
                var error = 'Please refresh the page.';
                return ($q.reject(error));
            }
            if (response.data.error) {
                return ($q.reject(response.data.error_description));
            }
            else {
                return ($q.reject(response.data.Message));
            }
            //TODO: Need to check if more error types come. If so return response.data and handle in controller
        }

        function handleSuccessToken(response) {
            writeServiceLog(JSON.stringify(response.data), "");
            var globals = $sessionStorage.get('globals');
            service.SetCredentials(globals.currentUser.username, globals.currentUser.clientId, globals.currentUser.role, response.data.access_token, response.data.refresh_token, globals.currentUser.moduleaccess);
            return (response.data);
        }

        function handleErrorToken(response) {
            writeServiceLog(JSON.stringify(response), "");
            var globals = $sessionStorage.get('globals');
            var accesstoken = globals.currentUser.token;
            var refreshtoken = globals.currentUser.refresh_token;
            service.SetCredentials(globals.currentUser.username, globals.currentUser.clientId, globals.currentUser.role, accesstoken, refreshtoken, globals.currentUser.moduleaccess);
            return ($q.reject(response.data.Message));
            // Otherwise, use expected error message.
        }
    }
    dataService.$inject = ['$http', '$rootScope', '$q', '$sessionStorage','$log'];
    angular.module('iTAWApp')
        .factory('dataService', dataService);
  

})();
