/* ====================================================================
 *
 * � 2010 Infosys Technologies Limited, Bangalore, India. All rights reserved. 
 * Infosys Test Automation Accelerator * Version: 6.7

 * Except for any open source software components embedded in this Infosys proprietary software program 
 * ("Program"), this Program is protected by copyright laws, international treaties and other pending or existing intellectual
 * property rights in India, the United States 
 * and other countries. Except as expressly permitted, any unauthorized reproduction, storage, transmission in any form 
 * or by any means (including without limitation electronic, mechanical, printing, photocopying, recording or otherwise),
 * or any distribution of this Program, or any portion of it, may result in severe civil and criminal penalties, and will be prosecuted to the maximum extent possible under the law.

 ======================================================================*/
/*****************************************************************************
 *   Revision History
 *   ------------------
 *   Name         :  LoginServiceImpl.java
 *   Author       :  Kirty_vs
 *   Date         :  10/August/2007
 *   Description  :  This is the implementation class for Login 
 * 					 service Module.
 *
 *   $Log		  :  LoginServiceImpl.java,v $
 *	 Modification Log
 * 	 Date                 Author                       Description
 * 	 ------------------------------------------------------------
 * 	 10/August/2007 	Kirty_vs 	          Created
 *   17-Jun-2008        Chitra_Subramanian    Added 2 new functions 
 *   										  strsessionId and setsessionId for performance tuning of ITAW
 *   13-Jul-2009	    Marian_Josephus	 	  Added rollback and transaction begin code to all functions with 
 *											  commit.
 *	 #  
 *	 #  
 *****************************************************************************/
package com.infosys.itaw.login.business.service.impl;

/* importing java classes */
import java.security.spec.KeySpec;
import java.util.ArrayList;
import java.util.Date;
import java.util.Properties;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import javax.xml.rpc.ServiceException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.infosys.itaw.login.business.service.LoginService;
/* importing ITAW classes */
import com.infosys.itaw.login.persistence.dao.LoginDAO;
import com.infosys.itaw.user.persistence.dto.UserDTO;

import itawexception.ItawException;
import sun.misc.BASE64Encoder;

/* importing radien classes */
//import com.infosys.j2ee.core.ServiceException;
//import com.infosys.j2ee.core.impl.RadienServiceLocator;
//import com.infosys.j2ee.infrastructure.service.logging.LoggingService; // import
// com.infosys.j2ee.infrastructure.service.notification.EmailNotificationMessage;
// import
// com.infosys.j2ee.infrastructure.service.notification.impl.EmailNotificationMessageImpl;
//import com.infosys.j2ee.infrastructure.service.notification.impl.EmailNotificationService;
//import com.infosys.j2ee.subframework.persistence.dao.DAOService;
//import com.infosys.j2ee.subframework.persistence.dao.DAOServiceException;
//import com.infosys.j2ee.subframework.persistence.dao.DBException;
//import com.infosys.j2ee.subframework.persistence.dao.HibernateDBException;
//import com.infosys.j2ee.subframework.persistence.dao.impl.HibernateSessionUtil;

/**
 * Implementation class for LoginService.java
 * 
 * @author Kirty_vs
 */
@SuppressWarnings("unchecked")
@Service("LoginService")
@Transactional
public class LoginServiceImpl implements LoginService {
	@Autowired
	LoginDAO loginDAO;
	//DAOService hibernateDAOService = null;
	//LoggingService log = null;
	//LoginDAO loginDAO = null;
	// org.hibernate.Session session;
	//EmailNotificationService emailService = null;
	private KeySpec keySpec;
	private SecretKeyFactory keyFactory;
	private Cipher cipher;

	/***************************************************************************
	 * The code below is Service based
	 **************************************************************************/

	public void destroy() {
		// TODO Auto-generated method stub

	}

	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

	public void start() {
		// TODO Auto-generated method stub

	}

	public void stop()  {
		// TODO Auto-generated method stub

	}

	/**
	 * initialise the services
	 * 
	 * @param
	 * @return
	 * @throws ServiceException
	 */
	public void init(){
		// get an instance of DAOService
		// hibernateDAOService =
		// (DAOService)RadienServiceLocator.getInstance().getService("default-HibernateDAOService");

		// get an instance of LoggingService
		// log =
		// (LoggingService)RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");

		// get an instance of EmailNotification Service
		// emailService =
		// (EmailNotificationService)RadienServiceLocator.getInstance().getService("default-NotificationService");

	}

	public LoginServiceImpl() throws ItawException {
/*		super();
		try {
			// get an instance of DAOService
			hibernateDAOService = (DAOService) RadienServiceLocator.getInstance().getService("default-HibernateDAOService");

			// get an instance of LoggingService
			//log = (LoggingService) RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
			//loginDAO = (LoginDAO) hibernateDAOService.getDAO("LoginDAO");
			// session=HibernateSessionUtil.currentSession("testfactory");
		} catch (DAOServiceException e) {
			throw new ItawException("ITAW11084");*/
		//}
		/*
		 * catch (DBException e) { throw new ItawException("ITAW11085"); }
		 */
	/*	catch (Exception e) {
			// System.out.println("Service Initialization error");
			throw new ItawException("ITAW11086");
		}*/

	}

	/**
	 * Retrieves the privileges associated to user
	 * 
	 * @param iUserId-Id
	 *            of the user
	 * @return lstResult-array list of all the privileges associated to the user
	 * @throws ItawException
	 */
	public ArrayList arrValidateRole(int iUserId) throws ItawException {
		ArrayList lstResult = null;
		try {
			// create an instance of LoginDAO
			// loginDAO = (LoginDAO)hibernateDAOService.getDAO("LoginDAO");

			// calling the arrGetPrivileges method of LoginDAO to get a
			// arraylist of privileges
			lstResult = loginDAO.arrGetPrivileges(iUserId);

		}
		// catch(ServiceException serviceException){
		// throw new ItawException("ITAW2511");
		// }
		catch (ItawException ItawException) {
			throw ItawException;
		} catch (Exception exception) {
			throw new ItawException("ITAW2512");
		} finally {
			loginDAO.closeSession();
			/*try {

				loginDAO.closeSession();

			} catch (DBException dbe) {
				throw new ItawException("ITAW11325");
			}*/
		}
		return lstResult;
	}

	/**
	 * Retrive the projects of a particular user
	 * 
	 * @param iUserId-Id
	 *            of the user toolType for setting the tools searchFlag to
	 *            determine if a normal load or search //Top-Down approach
	 *            searchName to search against the project names //Top-Down
	 *            approach
	 * @return arrProject-arraylist of projects of a particular user
	 * @throws ItawException
	 */
	// public ArrayList arrLstProject(int iUserId,ArrayList toolType) throws
	// ItawException { //Top-Down approach
/*	public ArrayList arrLstProject(int iUserId, ArrayList toolType, int searchFlag, String searchName) throws ItawException { // Top-Down
		// approach
		ArrayList arrProject = null;
		try {
			// create an instance of LoginDAO
			// loginDAO = (LoginDAO)hibernateDAOService.getDAO("LoginDAO");
			// System.out.println("inside arrLstProject IMpl");
			// calling the arrLstProject method of LoginDAO to get a arraylist
			// of projects
			// arrProject=loginDAO.arrLstProject(iUserId,toolType); //Top-Down
			// approach
			arrProject = loginDAO.arrLstProject(iUserId, toolType, searchFlag, searchName); // Top-Down
			// approach

		}
		// catch(ServiceException serviceException){
		// throw new ItawException("ITAW2527");
		// }
		catch (ItawException ItawException) {
			throw ItawException;
		} catch (Exception exception) {
			throw new ItawException("ITAW2528");
		} finally {loginDAO.closeSession();
//			try {
//
//				
//
//			} catch (DBException dbe) {
//				throw new ItawException("ITAW11326");
//			}
		}
		return arrProject;
	}
*/
	// for SSO
	public int intValidateUser(String strUserName) throws ItawException {
		int iResult = 0;
		try {
			// calling the intCheckUser method of LoginDAO
			iResult = loginDAO.intCheckUser(strUserName);
			//log.info("ITAW-LoginServiceImpl", "iResult:" + iResult);
		} catch (ItawException ItawException) {
			throw ItawException;
		} catch (Exception exception) {
			throw new ItawException("ITAW2514");
		} finally {
			loginDAO.closeSession();
//			try {
//				
//			} catch (DBException dbe) {
//				throw new ItawException("ITAW11327");
//			}
		}
		return iResult;
	}

	/**
	 * Checks if the user exist
	 * 
	 * @param userDto-object
	 *            of UserDTO
	 * @return user id on sucess
	 * @throws ItawException
	 */
	public int intValidateUser(UserDTO userDto) throws ItawException {
		int iResult = 0;

		// get the user name and password from userVO
		String strUserName = userDto.getStrUserName();
		String strPassword = userDto.getStrPassword();
		try {

			// Encrytping Password
			strPassword = encrypt(strPassword);

			// create an instance of LoginDAO
			// loginDAO = (LoginDAO)hibernateDAOService.getDAO("LoginDAO");

			// calling the intCheckUser method of LoginDAO
			iResult = loginDAO.intCheckUser(strUserName, strPassword);
			//log.info("ITAW-LoginServiceImpl", "iResult:" + iResult);

		}
		// catch(ServiceException serviceException){
		// throw new ItawException("ITAW2513");
		// }
		catch (ItawException ItawException) {
			throw ItawException;
		} catch (Exception exception) {
			throw new ItawException("ITAW2514");
		} finally {
			loginDAO.closeSession();
//			try {
//
//				
//
//			} catch (DBException dbe) {
//				throw new ItawException("ITAW11327");
//			}
		}
		return iResult;
	}

	/**
	 * @param strPassword
	 * @return
	 */
	public String encrypt(String strPassword) throws ItawException {
		String encryptionKey = "123456789012345678901234567890";
		String encryptionScheme = "DES";

		try {

			byte[] keyAsBytes = encryptionKey.getBytes("UTF8");
			keySpec = new DESKeySpec(keyAsBytes);

			keyFactory = SecretKeyFactory.getInstance(encryptionScheme);
			cipher = Cipher.getInstance(encryptionScheme);

			SecretKey key = keyFactory.generateSecret(keySpec);
			cipher.init(Cipher.ENCRYPT_MODE, key);
			byte[] cleartext = strPassword.getBytes("UTF8");
			byte[] ciphertext = cipher.doFinal(cleartext);

			BASE64Encoder base64encoder = new BASE64Encoder();
			return base64encoder.encode(ciphertext);

		} catch (Exception e) {
			throw new ItawException("ITAW2523");
		}

	}

	/**
	 * Get new password in case user forgets password
	 * 
	 * @param strUserName-Name
	 *            of the user
	 * @return TRUE on success
	 * @throws ItawException
	 */
	public boolean isGetNewPassword(String strUserName) throws ItawException {

		String strNewPassword = "";
		String strEmail = "";
		String strEncryptedPassword = "";
		boolean isCheck = false;
		try {
			// Logic for creating password
			strNewPassword = strUserName + String.valueOf(Math.round(Math.random() * 10000));
			//log.info("ITAW-LoginServiceImpl", "New password:" + strNewPassword + "UserName:" + strUserName);

			strEncryptedPassword = encrypt(strNewPassword);
			// creating an instance of LoginDAO
			// loginDAO = (LoginDAO)hibernateDAOService.getDAO("LoginDAO");

			// calling the boolForgetPassword method of LoginDAO
			strEmail = loginDAO.strForgetPassword(strUserName, strEncryptedPassword);
			// System.out.println(strEmail);
			// check if user requesting change password is valid
			if (strEmail.length() > 0) {
				isCheck = true;

				// SUBSTITUTE YOUR EMAIL ADDRESSES HERE!!!
				String to = "iis_ITAW@tvmsmtp.com";
				String from = "admin@ITAW.com";
				// SUBSTITUTE YOUR ISP'S MAIL SERVER HERE!!!
				String host = "10.154.116.140";

				// Create properties, get Session
				Properties props = new Properties();

				// If using static Transport.send(),
				// need to specify which host to send it to
				props.put("mail.smtp.host", host);
				// To see what is going on behind the scene
				props.put("mail.debug", "true");
				// props.put("mail.smtp.port","2525");
				// props.put("mail.user",to);
				Session session = Session.getInstance(props);

				// Instantiatee a message
				Message msg = new MimeMessage(session);

				// Set message attributes
				msg.setFrom(new InternetAddress(from));
				InternetAddress[] address = { new InternetAddress(to) };
				msg.setRecipients(Message.RecipientType.TO, address);
				msg.setSubject("New Password");
				msg.setSentDate(new Date());

				// Set message content
				msg.setText("Username: " + strUserName + " ,New Password: " + strNewPassword);

				// Send the message
				Transport.send(msg);

			}

		}
		// catch(ServiceException serviceException){
		// throw new ItawException("ITAW2515");
		// }
		catch (ItawException ItawException) {
			throw ItawException;
		} catch (Exception exception) {
			throw new ItawException("ITAW2516");
		}
		return isCheck;

	}

	public void changePassword(String strUserName, String strPassword) throws ItawException {

		String strEncryptedPassword = "";

		try {
			// Begining transaction
			loginDAO.getSession().beginTransaction();

			strEncryptedPassword = encrypt(strPassword);
			// creating an instance of LoginDAO
			// loginDAO = (LoginDAO)hibernateDAOService.getDAO("LoginDAO");

			// calling the boolForgetPassword method of LoginDAO
			loginDAO.strForgetPassword(strUserName, strEncryptedPassword);
			loginDAO.getTransaction().commit();

		}
		// catch(ServiceException serviceException){
		// throw new ItawException("ITAW2533");
		// }
		catch (ItawException ItawException) {
			// Rollback code
			loginDAO.getTransaction().rollback();
//			try {
//				
//			} catch (HibernateDBException dbe) {
//				throw new ItawException("ITAW12501");
//			} catch (DBException dbe) {
//				throw new ItawException("ITAW12502");
//			}
			throw ItawException;
		} catch (Exception exception) {
			// Rollback code
			loginDAO.getTransaction().rollback();
//			try {
//				
//			} catch (HibernateDBException dbe) {
//				throw new ItawException("ITAW12503");
//			} catch (DBException dbe) {
//				throw new ItawException("ITAW12504");
//			}
			throw new ItawException("ITAW2534");
		} finally {
			loginDAO.closeSession();
//			try {
//
//				
//
//			} catch (DBException dbe) {
//				throw new ItawException("ITAW11328");
//			}
		}

	}

	/*public int iprojectType(int projectId, String userName) throws ItawException {
		int projectType = 0;
		try {
			// create an instance of LoginDAO
			// loginDAO = (LoginDAO)hibernateDAOService.getDAO("LoginDAO");

			// calling the arrLstProject method of LoginDAO to get a arraylist
			// of projects
			projectType = loginDAO.iprojectType(projectId, userName);

		}
		// catch(ServiceException serviceException){
		// throw new ItawException("ITAW2527");
		// }
		catch (ItawException ItawException) {
			throw ItawException;
		} catch (Exception exception) {
			throw new ItawException("ITAW12623");
		} finally {
			loginDAO.closeSession();
//			try {
//
//			
//
//			} catch (DBException dbe) {
//				throw new ItawException("ITAW11329");
//			}
		}
		return projectType;
	}

	*//**
	 * Returns the session id corresponding to the user id.New function added
	 * for Performance tuning.
	 * 
	 * @param userId-Id
	 *            of User
	 * @return sessionId
	 * @throws ItawException
	 * @Modification Log Date Author Description
	 *               ----------------------------------------------------------------------
	 *               17-Jun-2008 Chitra_Subramanian Added a new function
	 *               setsessionId for performance tuning of ITAW
	 *//*
	public String strsessionId(int userId) throws ItawException {
		String strSessionId;
		try {
			// create an instance of LoginDAO
			// loginDAO = (LoginDAO)hibernateDAOService.getDAO("LoginDAO");

			// calling the strsessionId method of LoginDAO.
			strSessionId = loginDAO.strsessionId(userId);

		}
		// catch(ServiceException serviceException){
		// throw new ItawException("ITAW2527");
		// }
		catch (ItawException ItawException) {
			throw ItawException;
		} catch (Exception exception) {
			throw new ItawException("ITAW12624");
		} finally {
			loginDAO.closeSession();

//			try {
//
//				
//			} catch (DBException dbe) {
//				throw new ItawException("ITAW11330");
//			}
		}
		return strSessionId;
	}

	*//**
	 * Sets the session id corresponding to the user id.New function added for
	 * Performance tuning.
	 * 
	 * @param strUserId-Id
	 *            of User
	 * @param strSessionId-Session
	 *            Id
	 * @return iResult int
	 * @throws ItawException
	 * @Modification Log Date Author Description
	 *               ----------------------------------------------------------------------
	 *               17-Jun-2008 Chitra_Subramanian Added a new function
	 *               setsessionId for performance tuning of ITAW
	 *//*
	public int setsessionId(int userId, String strSessionId) throws ItawException {
		int iResult = 0;
		try {
			// create an instance of LoginDAO
			// loginDAO = (LoginDAO)hibernateDAOService.getDAO("LoginDAO");
			// Begining transaction
			loginDAO.getSession().beginTransaction();
			// calling the setsessionId method of LoginDAO
			iResult = loginDAO.setsessionId(userId, strSessionId);
			loginDAO.getTransaction().commit();

		}
		// catch(ServiceException serviceException){
		// throw new ItawException("ITAW2527");
		// }
		catch (ItawException ItawException) {
			// Rollback code
			loginDAO.getTransaction().rollback();
//			try {
//				
//			} catch (HibernateDBException dbe) {
//				throw new ItawException("ITAW12501");
//			} catch (DBException dbe) {
//				throw new ItawException("ITAW12502");
//			}
			throw ItawException;
		} catch (Exception exception) {
			// Rollback code
			loginDAO.getTransaction().rollback();
//			try {
//				
//			} catch (HibernateDBException dbe) {
//				throw new ItawException("ITAW12503");
//			} catch (DBException dbe) {
//				throw new ItawException("ITAW12504");
//			}
			throw new ItawException("ITAW12625");
		} finally {
			loginDAO.closeSession();
//			try {
//
//			
//
//			} catch (DBException dbe) {
//				throw new ItawException("ITAW11331");
//			}
		}
		return iResult;
	}

	*//***************************************************************************
	 * 
	 *//*
	public ArrayList getPlatformandToolList() throws ItawException {
		ArrayList lstPlatform = null;
		try {
			lstPlatform = loginDAO.getPlatformandToolList();
		} catch (Exception ex) {
			throw new ItawException("ITAW11331");
		}
		return lstPlatform;
	}*/
}
