/* ====================================================================
 *
 * � 2010 Infosys Technologies Limited, Bangalore, India. All rights reserved. 
 * Infosys Test Automation Accelerator * Version: 6.7

 * Except for any open source software components embedded in this Infosys proprietary software program 
 * ("Program"), this Program is protected by copyright laws, international treaties and other pending or existing intellectual
 * property rights in India, the United States 
 * and other countries. Except as expressly permitted, any unauthorized reproduction, storage, transmission in any form 
 * or by any means (including without limitation electronic, mechanical, printing, photocopying, recording or otherwise),
 * or any distribution of this Program, or any portion of it, may result in severe civil and criminal penalties, and will be prosecuted to the maximum extent possible under the law.

 ======================================================================*/
/*****************************************************************************
*
*   Revision History
*   ------------------
*
*   Name         :  ProjectService.java
*
*   Author       :  Ajeeti_s
*
*   Date         : 30/july/2007
*
*   Description  :  This is the service class for project
*
*   $Log:            ProjectService.java,v $
#
#
#
***************************************************************************/
package com.infosys.itaw.project.business.service;
/*importing the java classes*/
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import itawexception.ItawException;

import com.infosys.itaw.project.persistence.dto.*;



@Component
public interface ProjectService  {
	
	public String createProject(ProjectDTO ProjectVO)throws ItawException;
	
	public String deleteProject(int iProjectId)throws ItawException;
	
	public String modifyProject(ProjectDTO ProjectVO)throws ItawException;
	
	public List listProject()throws ItawException;
	
	public List listProject(int iProjectId)throws ItawException;
	
	public Map associateNewProjectUser(int[] newUserIds,int projectId)throws ItawException;
	
	/**
	 * checks whether a project name exists
	 * @param ProjectName the project name
	 * @return bcheckProject  True if exists
	 */
//	public boolean checkProjectExists(String ProjectName)throws ItawException;
	
	
	
	/**
	 * retrives details of a particular project
	 * @param iProjectId the project id
	 * @return lstProject list of projects
	 */
	
	/**
	 * retrives users of a particular project
	 * @param iProjectId the project id
	 * @return lstUsers list of users
	 */
//	public List fetchUsers(int iProjectId)throws ItawException;
	/**
	 * retrives application platforms of a particular project
	 * @param iProjectId the project id
	 * @return lstAppPlatform list of application platforms
	 */
//	public List fetchAppPlatform(int iProjectId)throws ItawException;
	/**
	 * retrives all application platforms
	 * @return lstAppPlatform list of application platforms
	 */
//	public List listAppPlatforms()throws ItawException;
	/**
	 * retrives all users
	 * @return lstUsers list of users
	 */
	
	
/*
	public List listUsers()throws ItawException;
	public int copyProject(int iFlag,int iFromProject,int iToProject, int iflag2)throws ItawException;
	
	public int disassociateProjectUser(int[] userIds,int projectId)throws ItawException;
	public int associateNewProjectAppPlatform(int newAppPlatformIds,int projectId)throws ItawException;
	public int disassociateProjectAppPlatform(int appPlatformId,int projectId)throws ItawException;
	public List searchUser(String strUserName) throws ItawException;
	public List searchAppPlatform(String strAppPlatformName) throws ItawException;

	public boolean checkProjectDetails(int iFlag, int iFromProjectId, int iToProjectId, int iFlag2) throws ItawException;

	public int retrieveProjectId(String strProjectName)throws ItawException;

	public String fetchProjectToolType(int iPrjId)throws ItawException;
	
	public String[] fetchProjectToolVersion(String Property)throws ItawException;*/
	
}
