
package com.infosys.itaw.project.business.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.infosys.itaw.project.business.service.ProjectService;
import com.infosys.itaw.project.persistence.dao.ProjectDAO;
import com.infosys.itaw.project.persistence.dto.ProjectDTO;
import itawexception.ItawException;

@Service("ProjectService")
@Transactional
public class ProjectServiceImpl implements ProjectService {

@Autowired
ProjectDAO projectdao;
public List listProject() throws ItawException {
		// lstProject storesult the list of projects
		List lstProject = null;
		try {
			
			// invoking the DAO method and storesult the return value
			lstProject = projectdao.listProject();
			
			// log.info("itaa:log","retrieved the
			// Project:"+proj.getIProjectId()+" "+proj.getStrProjectName());
			
		}
		// catching exceptions
		/*
		 * catch(DAOServiceException daoException) { //session.clear(); throw
		 * new ItawException("ITAA0050"); }
		 */
		catch (ItawException itawException) {
			//ExceptionLogger.log(itawException, this.getClass());
			throw itawException;
		} catch (Exception e) {
			//ExceptionLogger.log(e, this.getClass());
			throw new ItawException("ITAA0051");

		} finally {
			try {

				projectdao.closeSession();

			} catch (Exception dbe) {
				//ExceptionLogger.log(dbe, this.getClass());
				throw new ItawException("ITAA11334");
			}
		}
		// returning the resultult
		return lstProject;
	}


	public List listProject(int iProjectId) throws ItawException {
	
		// lstProject storesult the list of projects
		List lstProject = null;
		
		try {
			
			lstProject = projectdao.listProject(iProjectId);
			ProjectDTO proj = (ProjectDTO) lstProject.get(0);
			//log.info("itaa:log", "retrieved the Project:" + proj.getIProjectId() + " " + proj.getStrProjectName());
			// session.clear();
		}
		/*
		 * catch(DAOServiceException daoException){ //session.clear(); throw new
		 * ItawException("ITAA0058"); }
		 */
		catch (ItawException itawException) {
			// session.clear();
			throw itawException;
		} catch (Exception exception) {
			// session.clear();
			throw new ItawException("ITAA0059");
	
		} finally {
			try {
	
				projectdao.closeSession();
	
			} catch (Exception dbe) {
				throw new ItawException("ITAA11338");
			}
		}
		// returning the resultult
		return lstProject;
	}
	
	
	
	
	// To hold script destination path or the project folder path - ITAA5.3
	static String strScriptDestPath = null;
	
	public String createProject(ProjectDTO project) throws ItawException {
		//log.info("itaa:log", "inside the create project methods");
		System.out.println("inside the create project methods");
		// This variable holds the return value of method
		boolean isCreate = false;
		int resultultPrjID=-1;
	
		String strProjectToolType = null;
		

		try {
			isCreate = projectdao.createProject(project);
			//projectdao.getTransaction().commit();
			System.out.println("~~~~~~~~~~~~"+project.getIProjectId());
		}catch (ItawException ItawException) {

			// Rollback code
			try {
				projectdao.getTransaction().rollback();
			/*} catch (HibernateDBException dbe) {
				ExceptionLogger.log(dbe, this.getClass());
				throw new ItawException("ITAA12501");
			} catch (DBException dbe) {
				ExceptionLogger.log(dbe, this.getClass());
				throw new ItawException("ITAA12502");
			}
			
*/
			}catch (Exception e) {
				// TODO: handle exception
				throw new ItawException("ITAA12501");
			}
			
			//ExceptionLogger.log(ItawException, this.getClass());
			throw ItawException;
		}catch (Exception e) {
			// Rollback code
			try {
				projectdao.getTransaction().rollback();
			}/* catch (HibernateDBException dbe) {
				ExceptionLogger.log(dbe, this.getClass());
				throw new ItawException("ITAA12503");
			} catch (DBException dbe) {
				ExceptionLogger.log(dbe, this.getClass());
				throw new ItawException("ITAA12504");
			}*/
			catch (Exception ex) {
				// TODO: handle exception
				throw new ItawException("ITAA12503");
			}
			
			//ExceptionLogger.log(e, this.getClass());
			// session.clear();
			throw new ItawException("ITAA0049");
		}finally {
			try {

				projectdao.closeSession();

			} catch (Exception ex) {
				//ExceptionLogger.log(dbe, this.getClass());
				throw new ItawException("ITAA11333");
			}
		}
		
		// returning the resultult
		if( isCreate)
			return Integer.toString(project.getIProjectId());
		else 
			return "Failed";
	}
	
	
	public String modifyProject(ProjectDTO ProjectVO)throws ItawException
	{
		String result="Update Failed";
		try
		{
			List list=projectdao.listProject(ProjectVO.getIProjectId());
			if(list.isEmpty())
			{
				result= result+": Invalid Project ID"; 
			}
			else if(projectdao.modifyProject(ProjectVO))
			{
				result= "Project ID "+Integer.toString(ProjectVO.getIProjectId())+" updated Successfully";			
			}
			//projectdao.getTransaction().commit();
		}
		catch (ItawException itawException) 
		{
			// Rollback code
			try {
				projectdao.getTransaction().rollback();
			/*} catch (HibernateDBException dbe) {
				throw new ItaaException("ITAA12501");
			} catch (DBException dbe) {
				throw new ItaaException("ITAA12502");
			}*/

			// session.clear();
			throw itawException;
			} 
			catch (Exception exception)
			{
				// Rollback code
				try {
					projectdao.getTransaction().rollback();
				} /*catch (HibernateDBException dbe) {
					throw new ItaaException("ITAA12503");
				} catch (DBException dbe) {
					throw new ItaaException("ITAA12504");
				}*/
				catch (Exception e) {
					// TODO: handle exception
					throw new ItawException("ITAA12503");
				}
				// session.clear();
				throw new ItawException("ITAA0055");
	
			}
			finally 
			{
					try {
		
						projectdao.closeSession();
		
					} catch (Exception dbe) {
						throw new ItawException("ITAA11336");
					}
			}
		
		}
		
		// returning the result
		return result;
	}
	
	
	public String deleteProject(int projID) throws ItawException
	{
		String result="Delete Operation Failed ";
		try{
			if(projectdao.listProject(projID).isEmpty())
			{
				result=result+ "Projecyt ID: " + Integer.toString(projID)+" not found";
			}
			else
			{	
				if(projectdao.deleteProject(projID))
					result=" Proj ID: "+Integer.toString(projID)+" Deleted";																	
			}
		}
		catch (Exception e) {
			// TODO: handle exception
			throw new ItawException("");
		}
		return result;
	}
	
	
	
	
	public Map associateNewProjectUser(int[] iUserIds, int iProjectId) throws ItawException {
		Map<Integer, String> mapResult =new HashMap<Integer,String>();
		try {
			int iUserSize = iUserIds.length;

			//log.info("ITAA-ProjectServiceImpl", "Associate Project: " + iProjectId + " to users: " + Arrays.toString(iUserIds));			
			for (int i = 0; i < iUserSize; i++) {
				
						//System.out.println(iUserIds[i]+" "+iProjectId);
						//log.info("ITAA-ProjectServiceImpl", "Associate User to Project");
				
				if(projectdao.checkProjectUserAssosiation(iUserIds[i],iProjectId))					
				{
					//throw new Exception("Unable to associate user "+iUserIds[i]+" to project "+iProjectId+": Association already Exist!");
					mapResult.put(iUserIds[i], "Existing");
					
					
				}
				else if(projectdao.associateNewProjectUser(iUserIds[i], iProjectId))
				{
					mapResult.put(iUserIds[i], "Inserted");
					//log.info("ITAA-ProjectServiceImpl-DB", "Association created/updated for " + iUserIds[i]);
				}					
				else 
				{
					//System.out.println("Else part");
					//throw new Exception("Unable to associate user to project!");
					mapResult.put(iUserIds[i], "Failed");
				}
			
			}
			//iResult = 1;

			//log.info("ITAA-ProjectServiceImpl", "Association Complete");

			// committing the transaction
			//projectdao.getTransaction().commit();
			//log.info("ITAA-ProjectServiceImpl", "Inserted successfully");
		} catch (ItawException itawException) {
			// Rollback code
			try {
				//projectdao.getTransaction().rollback();
			}/* catch (HibernateDBException dbe) {
				throw new ItaaException("ITAA12501");
			} catch (DBException dbe) {
				throw new ItaaException("ITAA12502");
			}
			
			ExceptionLogger.log(itaaException, this.getClass());
			// session.clear();*/			
			catch (Exception e) {
				throw new ItawException("ITAA12502" );
				// TODO: handle exception
			}throw itawException;
		} catch (Exception exception) {
			// Rollback code
			try {
				projectdao.getTransaction().rollback();
			} /*catch (HibernateDBException dbe) {
				throw new ItaaException("ITAA12503");
			} catch (DBException dbe) {
				throw new ItaaException("ITAA12504");
			}
			ExceptionLogger.log(exception, this.getClass());
			// session.clear();*/
			catch (Exception e) {
				throw new ItawException("ITAA12504");
				// TODO: handle exception
			}
			throw new ItawException("ITAA0069");

		} catch (Throwable t) {
			System.out.println(t.getMessage());
		} finally {
			try {
				//projectdao.closeSession();
			} catch (Exception e) {	// (DBException dbe)
				throw new ItawException("ITAA11343");
			}
		}
		return mapResult;
	}
	
}