package com.infosys.itaw.project.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.google.gson.Gson;
import com.infosys.itaw.project.business.service.ProjectService;
import com.infosys.itaw.project.persistence.dto.ProjectDTO;

import itawexception.ItawException;

@RestController
public class ProjectController {
	
	@Autowired
	ProjectService projectservice;
	
	// ~~~~~~~~~~~~~~~~~~~~List all projects~~~~~~~~~~~~~~	
	@RequestMapping("/projects")
	public String getAllProjects() throws ItawException
	{
		
		List listProjects=projectservice.listProject();
		String str=new Gson().toJson(listProjects);
		return str;		
	}
	
	//~~~~~~~~~~~~Return Project of the given ID~~~~~~~~~~~~~
	 @RequestMapping("/projects/{id}")
	 public String getUserByID (@PathVariable("id") int iProjectId) throws ItawException {
		// ResponseEntity<List<User>>
	    	List listProj = projectservice.listProject(iProjectId);
	    	String strJson = new Gson().toJson(listProj);    	  
	        return strJson;
	 }
	 
	 
	 
	 //~~~~~~~~~~~Create Project~~~~~~~~~~~~	 
	 /*
	@RequestMapping(value="/createProject/",method=RequestMethod.POST)
	@CrossOrigin(origins = "*", maxAge = 3600, allowedHeaders = { "x-auth-token", "x-requested-with" })
	@ResponseBody
	 public String createProject(@RequestBody ProjectDTO project) throws ItawException {							
		}		
	*/	
	@RequestMapping("/createProject")
	public String createProject() throws ItawException
	{
		ProjectDTO testProject=new ProjectDTO();
		
				
		testProject.setIProjectType(2);
		testProject.setStrProjectName("testWS");
		testProject.setStrBddType(null);
		testProject.setStrManager("test");
		testProject.setStrManagerEmail("test@infy.com");
		testProject.setStrProjectCode("test");
		testProject.setStrProjectDesc("test");
		testProject.setStrProjectToolType("Selenium");
		testProject.setStrProjectToolVersion("Webdriver");
		
		return (projectservice.createProject(testProject));
	}
	 
	
	//~~~~~~~~~~~~Update Project~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	/*
	@RequestMapping(value="/updateProject/",method=RequestMethod.POST)
	@CrossOrigin(origins = "*", maxAge = 3600, allowedHeaders = { "x-auth-token", "x-requested-with" })
	@ResponseBody
	 public String createProject(@RequestBody ProjectDTO project) throws ItawException {
			
			int projID=projectservice.createProject(project);
			return Integer.toString(projID);
			
		}		
	*/
	@RequestMapping("/updateProject")
	public String updateProject() throws ItawException
	{
		String res=null;
		
		ProjectDTO testProject=new ProjectDTO();
		
		
		testProject.setIProjectId(10);
		
		testProject.setIProjectType(2);
		testProject.setStrProjectName("updatedtestWS");
		testProject.setStrBddType(null);
		testProject.setStrManager("test");
		testProject.setStrManagerEmail("test@infy.com");
		testProject.setStrProjectCode("test");
		testProject.setStrProjectDesc("test");
		testProject.setStrProjectToolType("Selenium");
		testProject.setStrProjectToolVersion("Webdriver");
				
		return projectservice.modifyProject(testProject);
		
	}

	
	@RequestMapping("/deleteProject/{id}")
	public String deleteProject(@PathVariable("id") int projID)	throws ItawException
	{
		return projectservice.deleteProject(projID);
	}
	
	
	
	@RequestMapping("/assosiateUsers")
	public String assosiateUsers() throws ItawException	
	{
		int userIDs[]={1,2,3,4};
		int projectID=8;				
		return new Gson().toJson(projectservice.associateNewProjectUser(userIDs, projectID));
	}
	
	
	
}
