package com.infosys.itaw.project.persistence.dao;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.hibernate.Query;
import org.springframework.stereotype.Repository;

import com.infosys.itaw.project.persistence.dto.ProjectDTO;
import com.infosys.itaw.project.persistence.dto.ProjectUsersDTO;
import com.infosys.itaw.util.GenericHibernateDAO;

import itawexception.ItawException;

@Repository
public class ProjectDAO extends GenericHibernateDAO{
	
	public List listProject() throws ItawException {
		
		List lstProj = null;
		String strQuery;
		Query query;
		
		try {
			
			//lstProject = (List) executeHQLQuery("from ProjectDTO order by IProjectId desc");

			//logService.info("itaa:log:", "retrieved the projects");
			strQuery = this.getSQL("SELECT_PROJECTS");
			query = (Query) this.createQuery(strQuery);
			lstProj = (List) query.list();
			//BBN
			System.out.println(" ITAA-UserDAO"+ "retrieved the users");

		
		
		/*}catch (DBException dbException) {
			dbException.printStackTrace();
			throw new ItawException("ITAA0008");*/
		} catch (Exception exception) {
			exception.printStackTrace();
			throw new ItawException("ITAA0009");
		}
		// returning the result
		return lstProj;
	}

	/**
	 * @param iProjectId
	 *            the project id
	 * @return lstProject list of projects
	 */
	
	public List listProject(int iProjectId) throws ItawException {
		// LoggingService logService=null;

		// lstproject is used to store the list of Projects		
		List lstProj = null;
		String strQuery;
		Query query;
		
		try {
			// logService=(LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
			strQuery = this.getSQL("SELECT_BY_ID");
			query = (Query) this.createQuery(strQuery);
			//lstProj = (List) query.list();
			
			
			lstProj = (ArrayList) query.setInteger(0, iProjectId).list();
			
			//BBN
			System.out.println(" ITAA-UserDAO"+ "retrieved the user");
			// Retrieve all the Projects from table
			//lstProject = (List) executeHQLQuery("from ProjectDTO where IProjectId=" + iProjectId + "");
			//throw new ItawException("ITAA0011");
		}catch (Exception exception){
			exception.printStackTrace();
			throw new ItawException("ITAA0012");
		}
		return lstProj;
	}
	
	public boolean createProject(ProjectDTO project) throws ItawException {
		// LoggingService logService=null;
		
		// iResult is used to store and return the success value
		boolean isCreate = false;

		try {
			
			create(project);
			isCreate=true;
						
		}
		/*
		 * catch(ServiceException serviceException) {
		 * 
		 * serviceException.printStackTrace(); throw new
		 * ItawException("ITAA0001"); }
		 */
		/*catch (DBException dbException) {
			dbException.printStackTrace();
			throw new ItawException("ITAA0002");
		}*/ 
		catch (Exception exception) {
			exception.printStackTrace();
			throw new ItawException("ITAA0003");
		}
		// return the result
		return (isCreate);
	}
	
	public boolean modifyProject(ProjectDTO project) throws ItawException
	{
		
		boolean isModified=false;
		String sql;
		Query query;
		try{
			//update(project);
			sql=this.getSQL("UPDATE_PROJECT");
			query=this.createQuery(sql);
			//prj_nm=?,prj_desc=?,prj_cd=?,prj_mngr=?,prj_mngr_email=?,prj_type=?,tool_type=?,tool_ver=?,bdd_type=?  where  prj_id=?
			query.setParameter(0, project.getStrProjectName());
			query.setParameter(1, project.getStrProjectDesc());
			query.setParameter(2, project.getStrProjectCode());
			query.setParameter(3, project.getStrManager());
			query.setParameter(4,project.getStrManagerEmail());	
			query.setInteger(5,project.getIProjectType());
			query.setParameter(6, project.getStrProjectToolType());
			query.setParameter(7, project.getStrProjectToolVersion());
			query.setParameter(8, project.getStrBddType());
			
			query.setInteger(9, project.getIProjectId());
			
			if(query.executeUpdate() !=0)
				isModified=true;
		}
		/*catch (DBException dbException) {
			dbException.printStackTrace();
			throw new ItawException("ITAA0017");
		}*/
		catch (Exception exception) {
			exception.printStackTrace();
			throw new ItawException("ITAA0018");
		}
		
		return isModified;
	}
	
	public boolean deleteProject(int projID) throws ItawException
	{
		boolean isDelete=false;
		try
		{							
			String hql=this.getSQL("DELETE_PROJECT");
			Query deleteQuery=this.createQuery(hql);
			deleteQuery.setInteger(0, projID);			
			deleteQuery.executeUpdate();
			isDelete=true;
			
		}catch (Exception e) {
			// TODO: handle exception			
			throw new ItawException(" ");
		}
		
		return  isDelete;
	}
	
	
	public boolean checkProjectUserAssosiation(int iUserID,int iProjectID) throws ItawException
	{
		
		boolean result=true;
		String checkUserHql;
		Query query;
		try
		{			
			checkUserHql=this.getSQL("CHECK_PROJECTUSER");
			query=this.createQuery(checkUserHql);
			query.setInteger(0, iUserID);
			query.setInteger(1, iProjectID);
			List list=query.list();
			/*System.out.println("~~~~~~~~~~~~~~ Inside dao");
			System.out.println(" Lsit : "+list.size());*/
			if( list.isEmpty() )
			{				
				System.out.println("~~~~~~~~~~~Assosiation Doesnt Exists");
				result=false;
			}
		
		}catch (Exception e) {			
			e.printStackTrace();
		}
		return result;
	}
	
	public boolean associateNewProjectUser(int iUserId, int iProjectId) throws ItawException {
		boolean result = false;
		List lstUser = null;
		// LoggingService logService=null;
		try {
				ProjectUsersDTO projectUser = new ProjectUsersDTO();	
				projectUser.setIUserId(iUserId);
				projectUser.setIProjectId(iProjectId);			
//				create(projectUser);
				saveOrUpdate(projectUser);
				result=true;
				System.out.println("~~~~~~~~~~~~~~~~~~~~~~~create operation");
				
		}
		/*
		 * catch(ServiceException serviceException) {
		 * serviceException.printStackTrace(); throw new
		 * ItawException("ITAA0034"); }
		 */
		/*catch (DBException dbException) {
			dbException.printStackTrace();
			throw new ItawException("ITAA0035");
		} */
		catch (Exception exception) {
			System.out.println("create Failed");
			exception.printStackTrace();
			throw new ItawException("ITAA0036");
		}
		return result;
	}
	
	
}