package com.infosys.itaw.role.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.google.gson.Gson;
import com.infosys.itaw.role.business.service.RoleService;
import com.infosys.itaw.role.persistence.dto.RoleDTO;

import itawexception.ItawException;



@RestController
public class RoleController {
	@Autowired
	RoleService roleService;
	//-------------------Get all roles--------------------------------------------------------
	 @RequestMapping("/roles")
    public String getAllRoles () throws ItawException {
    	
    	List listRoles = roleService.listRoles();
    	String json = new Gson().toJson(listRoles);    	  
        return json;
    } 
	
	 
	//-------------------Create a Role--------------------------------------------------------
     
	    @RequestMapping(value = "/role/", method = RequestMethod.GET)
	    public int createRole() {
	    	
	        RoleDTO role = new RoleDTO();
	        role.setIEnableStatus(1);
	        role.setStrRoleDesc("Super user");
	        role.setStrRoleName("Admin1");
	        int roleId=0;
	        System.out.println("Creating role " + role.getStrRoleName());
	        try {
//				if (roleService.checkRoleExists(role.getStrRoleName())) {
//				    System.out.println("A Role with name " + role.getStrRoleName() + " already exist");
//				    return new ResponseEntity<Void>(HttpStatus.CONFLICT);
//				}
	        	 roleId = roleService.createRole(role);
			} catch (ItawException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	 
	        return roleId;
	    }
	  
	    
	  //-------------------Delete a Role--------------------------------------------------------
	     
	    @RequestMapping(value = "/roledelete", method = RequestMethod.GET)
	    /**
		 * deletes the roles
		 * @param roleID
		 * @return 1 on successful deletion
		 */
		public int deleteRoles()throws ItawException{
			
			//stores the return value of method
			int iResult=0;
			int iRoleId=8;
			try
			{				
				////log=(LoggingService)RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
				System.out.println("Role Action : deleteRoles "+"entered roleAction"); 		
				//instance of role service is created			
				////roleService=(RoleService)RadienServiceLocator.getInstance().getService("ITAW-RoleService");
				//initialising the service
				//roleService.init();
				//invoking deleteRoles method in service class
				iResult = roleService.deleteRoles(iRoleId);
				System.out.println("Role Action : deleteRoles "+"iResult ="+iResult);
				if(iResult == 1)
				{
					System.out.println("Role Action : deleteRoles "+iRoleId+" is deleted.... ");
				}
				else
				{
					System.out.println("Role Action : deleteRoles "+iRoleId+" is not deleted.... ");
				}	
			}
			/*catch(ServiceException serviceException)
			{	
				throw new ItawException("ITAW1036");	
			}*/
			catch(ItawException ItawException)
			{	
				throw ItawException;
			}
			catch(Exception exception)
			{
				throw new ItawException("ITAW1037");
			}
			//return the value stored in iResult to the front end
			return iResult;
		}
	    
	    
	    //------------------- Modify a Role--------------------------------------------------------

		/**
		 * modify the role
		 * @param role
		 * @param iRoleId
		 * @param iEnableStatus
		 * @return 1 on successful modification
		 */
	    @RequestMapping(value = "/rolemodify", method = RequestMethod.GET)
		public int modifyRole()throws ItawException
		{
				//stores the return value of method
				RoleDTO role = new RoleDTO();
				int roleId=9;
		        role.setIEnableStatus(1);
		        role.setStrRoleDesc("Super user modify");
		        role.setStrRoleName("new Admin");
				int iResult=0;			
				try
				{
					
					////log=(LoggingService)RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
					//instance of role service is created
					////roleService=(RoleService)RadienServiceLocator.getInstance().getService("ITAW-RoleService");
					//System.out.println("RoleAction : Modify Role","RoleService : "+roleService);
					//initialising the service
					//roleService.init();
					System.out.println("RoleAction : modifyRole "+"Role info : "+role.getIRoleId()+role.getStrRoleName()+role.getIEnableStatus());
					//Invoking modifyRole method in Service class
					iResult = roleService.modifyRole(role,roleId);
					//to log success message
					if(1 == iResult)
					{
						System.out.println("RoleAction : Modify Role "+role.getStrRoleName()+" is modified..... ");	
					}
					//to log failure message  if rolename exists
					else if(2 == iResult)
					{
						System.out.println("RoleAction : Modify Role "+role.getStrRoleName()+"roleName already exists");
					}
					//to log failure message if any other error
					else	
					{
						System.out.println("RoleAction : Modify Role "+role.getStrRoleName()+" could not modify..... ");	
					}			
				}
				/*catch(ServiceException serviceException)
				{	
					throw new ItawException("ITAW1038");	
				}*/
				catch(ItawException ItawException)
				{	
					throw ItawException;
				}
				catch(Exception exception)
				{
					throw new ItawException("ITAW1039");
				}
				//return the value stored in iResult to the front end
				return iResult;
		}
		 
		//-------------------Fetch particular Role details--------------------------------------------------------
	    
	    /**
		 * fetch all the role details
		 * @return list of role details
		 */
	    @RequestMapping(value = "/roledetail", method = RequestMethod.GET)
		public List listRoleDetails() throws ItawException
		{
			//lstRole is used to store list of Roles
			List lstRole = null;
			int iRoleId = 3;
			try
			{
				//log=(LoggingService) RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
				//instance of role service is created
				//roleService = (RoleService)RadienServiceLocator.getInstance().getService("ITAW-RoleService");
				//initialising the service
				//roleService.init();
				//Invoking listRoleDetails method in Service class
				lstRole = roleService.listRoleDetails(iRoleId);
			}
			/*catch(ServiceException serviceException)
			{	
				throw new ItawException("ITAW1073");	
			}*/
			catch(ItawException ITAWException)
			{	
				throw ITAWException;
			}
			catch(Exception exception)
			{
				throw new ItawException("ITAW1074");
			}
			//return the result lstRole
			return lstRole;
		}
		
	    
	    //-------------------List all Privileges--------------------------------------------------------
	    
	    /**
		 * fetch all the privileges
		 * @return list of privileges
		 */
	    @RequestMapping(value = "/privileges", method = RequestMethod.GET)
		public List listAllPrivileges() throws ItawException 
		{
			//lstAllPrivileges is used to store list of privileges
			List lstAllPrivileges = null;
			try
			{
				//log=(LoggingService) RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
				//instance of role service is created
				//roleService = (RoleService)RadienServiceLocator.getInstance().getService("ITAW-RoleService");
				//initialising the service
				//roleService.init();
				//Invoking listAllPrivileges method in Service class
				lstAllPrivileges = roleService.listAllPrivileges();
				System.out.println("RolePrivilegeAction logger "+"Retrieved All Privileges:"+lstAllPrivileges.size());
			}
			/*catch(ServiceException serviceException)
			{	
				throw new ItawException("ITAW1075");	
			}*/
			catch(ItawException ItawException)
			{	
				throw ItawException;
			}
			catch(Exception exception)
			{
				throw new ItawException("ITAW1076");
			}
			//return the result lstAllPrivileges
			return lstAllPrivileges;
		}

	    
	    
}
