/* ====================================================================
 *
 * � 2010 Infosys Technologies Limited, Bangalore, India. All rights reserved. 
 * Infosys Test Automation Accelerator * Version: 6.7

 * Except for any open source software components embedded in this Infosys proprietary software program 
 * ("Program"), this Program is protected by copyright laws, international treaties and other pending or existing intellectual
 * property rights in India, the United States 
 * and other countries. Except as expressly permitted, any unauthorized reproduction, storage, transmission in any form 
 * or by any means (including without limitation electronic, mechanical, printing, photocopying, recording or otherwise),
 * or any distribution of this Program, or any portion of it, may result in severe civil and criminal penalties, and will be prosecuted to the maximum extent possible under the law.

 ======================================================================*/
/*****************************************************************************
 *   Revision History
 *   ------------------
 *   Name         :  UserDAO.java
 *   Author       :  Neha_mittal03
 *   Date         :  20/August/2007
 *   Description  :  This class represents Data Access object for Users
 *
 *   $Log		  :  UserDAO.java$
 *   Modification Log:
 *   * Date                 Author                     Description
 *   * ------------------------------------------------------------
 *	 * 20-Aug-2007          Neha_mittal03              Created
 *	 * 16-Jun-2008 			Abraham_Mammen			   Created function addSessionDetails for performance tuning
 *	 * 16-Jun-2008          Abraham_Mammen             Query added to delete from Session_details table in deleteUsers function.
 *	 * 31-Jul-2008			Shilpa_Nanoo			   searchUser,searchRole-Query changed to enable blank search and to arrange retrived result in alphabetic order
 *	 #
 *****************************************************************************/
package com.infosys.itaw.role.persistence.dao;

/* Importing java classes */
import java.util.ArrayList;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.springframework.stereotype.Repository;

import com.infosys.itaw.role.persistence.dto.RoleDTO;
import com.infosys.itaw.util.GenericHibernateDAO;

/* Importing radien classes 
import com.infosys.j2ee.core.ServiceException;
import com.infosys.j2ee.core.impl.RadienServiceLocator;
import com.infosys.j2ee.infrastructure.service.logging.LoggingService;
import com.infosys.j2ee.subframework.persistence.dao.HibernateException;
import com.infosys.j2ee.subframework.persistence.dao.impl.GenericHibernateDAO;
import com.infosys.j2ee.subframework.persistence.dao.impl.HibernateSessionUtil;
import com.licensing.DecryptTool;*/

import itawexception.ItawException;

/**
 * This is the DAO class for Manage User Module.
 * 
 * @author Neha_mittal03
 */
@Repository
public class RoleDAO extends GenericHibernateDAO {

	private String strQuery = null;
	private Query query = null;
	
	public RoleDAO() throws ItawException {
		try {
			//logService = (LoggingService) RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
		} //catch (ServiceException e) {
			//throw new ItawException("ITAW11022");
		//} 
	catch (Exception e) {
			// System.out.println("Service initialization error");
			throw new ItawException("ITAW11023");
		}
	}

	/**
	 * This method retrieves all the roles
	 * @return list of roles
	 */
	public List listRoles() throws ItawException
	  {
        //lstRole is used to store the list of Roles
		List lstRole=null;
		//LoggingService log=null;
		try
		{
		 //Retrieve all the Roles from the table
		 strQuery = this
					.getSQL("SELECT_ALL_ROLES");
			query = (Query) this.createQuery(strQuery);
			lstRole = (List) query.list();
		 
		 System.out.println("RoleDAO : List Roles"+" Retrieved Roles:"+lstRole.size());
		}
		/*catch (ServiceException serviceException)
		{
			//session.clear();
			service//exception.printStackTrace();
			throw new ItawException("ITAW1007");
		}*/
		catch (HibernateException HibernateException)
		{
			//session.clear();
//			//Hibernate//exception.printStackTrace();
			throw new ItawException("ITAW1008");
		}
		catch(Exception exception)
		{	
			//session.clear();
//			//exception.printStackTrace();
			throw new ItawException("ITAW1009");
		}
		//session.clear();
		//return the value stored in lstRole
		return lstRole;
	  }
	
	
	/**
	 * Creates a role
	 * @param role
	 * @return iResult 1 for success and 0 for failure
	 */
	public int createRole(RoleDTO role) throws ItawException{
		//LoggingService logService=null;
		//iResult is used to store and return the success value
		int iResult=0;
		try
		{
			//session=HibernateSessionUtil.currentSession("testfactory");
			//creating an instance of logging service
			//logService=(LoggingService) RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
			System.out.println("RoleDAO : createRole"+" create Roles:"+role.getStrRoleDesc());
			System.out.println("RoleDAO : createRole"+" create Roles:"+role.getStrRoleName());
			String strRoleName = role.getStrRoleName();
			if(checkRoleExists(strRoleName))
			{
				System.out.println("RoleDAO : createRole"+" CANNOT CREATE ROLE"+role.getStrRoleName());
				iResult = 2;
				System.out.println("RoleDAO : createRole "+"ROLE EXISTS"+iResult);
			}
			else
			{
			//Insert the role object to database
			
			iResult=(Integer)create(role);
			System.out.println("RoleDAO : createRole"+" Sucessfully Created Role:"+iResult);
			}
		}
		/*catch(ServiceException serviceException)
		{	
			//session.clear();
			service//exception.printStackTrace();
			throw new ItawException("ITAW1001");
		}*/
		catch(HibernateException HibernateException)
		{	
			//session.clear();
			//Hibernate//exception.printStackTrace();
			throw new ItawException("ITAW1002");
		}
		catch(Exception exception)
		{
			//session.clear();
			//exception.printStackTrace();
			throw new ItawException("ITAW1003");
		}
		//session.clear();
		//return the value stored in iResult
		return(iResult);
	}
	
	/**
	 * This method deletes  the role
	 * @param iRoleID
	 * @return 1 on successful deletion
	 */
	public int deleteRoles(int iRoleId) throws ItawException
	{
		//iResult is used to store and return the success value
		int iResult=0;
		//lstRoles is used to store list of roles
		List lstRoles = null;
		//LoggingService logService=null;
		try
		{
			//session=HibernateSessionUtil.currentSession("testfactory");
			RoleDTO role = new RoleDTO();
			//logService=(LoggingService) RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");	
//			lstRoles = (List) executeHQLQuery("from UserRoleDTO where IRoleId="+iRoleId);
//			System.out.println("RoleDAO : deleteRoles"+" size of lstRoles"+lstRoles.size());
//			int iRoleSize = lstRoles.size();
			//Deleting the role with given ID
//			if(0 == iRoleSize)
//			{
				System.out.println("RoleDAO : deleteRoles "+"Deleting Role"+iRoleId);
				role.setIRoleId(iRoleId);
				//delete(role);
				String query1 = this.getSQL("DELETE_ROLE");
				Query selQuery=(Query) this.createQuery(query1);
				iResult=selQuery.setInteger(0,iRoleId).executeUpdate();
		        
				//getTransaction().commit();
				
//			}
		}
//		catch (ServiceException serviceException)
//		{
//			//session.clear();
//			service//exception.printStackTrace();
//			throw new ItawException("ITAW1010");
//		}
		catch (HibernateException HibernateException)
		{
			//session.clear();
			//Hibernate//exception.printStackTrace();
			throw new ItawException("ITAW1011");
		}
		catch(Exception exception)
		{	
			//session.clear();
			//exception.printStackTrace();
			throw new ItawException("ITAW1012");
		}
		//session.clear();
		//return the value stored in iResult
		return iResult;
	}

	
	/* checks whether the role name already exists or not
	 * @param roleName
	 * @return True for exists
	 */
	public boolean checkRoleExists(String strRoleName)throws ItawException{
		//LoggingService logService=null;
		try
		{
			ArrayList roleList = new ArrayList();
			//session=HibernateSessionUtil.currentSession("testfactory");
			//logService=(LoggingService) RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
			//Retrieve all the rows with name as roleName
			strQuery = this.getSQL("SELECT_BY_ROLE_NAME");
			query = this.createQuery(strQuery);
			// Retrieve all the rows with name as strUserName
			
			query.setString(0, strRoleName);
			roleList = (ArrayList) query.list();
			//checks whether any row exists in database with the name roleNames
			int iRoleSize = roleList.size();
			if(0 == iRoleSize)
			{
				System.out.println("RoleDAO : checkRoleExists "+"The Role name does not exists");
				//session.clear();
				return false;
			}
			else{
				System.out.println("RoleDAO : checkRoleExists"+" The Role name already exists");
				//session.clear();
				return true;
			}
		}
//		catch (ServiceException serviceException)
//		{	
//			//session.clear();
//			service//exception.printStackTrace();
//			throw new ItawException("ITAW1004");
//		}
		catch (HibernateException HibernateException)
		{	
			//session.clear();
			//Hibernate//exception.printStackTrace();
			throw new ItawException("ITAW1005");
		}
		catch(Exception exception)
		{
			//session.clear();
			//exception.printStackTrace();
			throw new ItawException("ITAW1006");
		}
	}
	/*
	
	
	
	*//**
	 * checks whether the role id exists or not
	 * @param role
	 * @return True for exists
	 */
		public boolean checkRoleIdExists(RoleDTO role) throws ItawException
		{
			//LoggingService logService=null;
			try{
				//session=HibernateSessionUtil.currentSession("testfactory");
				//logService=(LoggingService) RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
				//Retrieve all the rows with name as roleName
				System.out.println("RoleDAO : checkRoleIdExists "+ "roleName = "+role.getStrRoleName());
				System.out.println("RoleDAO : checkRoleIdExists "+ "roleId = "+role.getIRoleId());
				
				strQuery = this
						.getSQL("CHECK_ROLEID");
				query = (Query) this.createQuery(strQuery);
				List roleNames = (List) query.setString(0, role.getStrRoleName()).setInteger(1, role.getIRoleId()).list();
				int iRoleNameSize = roleNames.size();
				//checks whether any row exists in database with the name roleNames
				if(0 == iRoleNameSize)
				{
					System.out.println("RoleDAO : checkRoleIdExists "+"The RoleName does not exist with a different Role Id");
					//session.clear();
					return true;
				}
				else{
					System.out.println("RoleDAO : checkRoleIdExists "+"The Role name already exists with a different Role Id");
					//session.clear();
					return false;
				}
			}
//			catch (ServiceException serviceException)
//			{	
//				//session.clear();
//				service//exception.printStackTrace();
//				throw new ItawException("ITAW1013");
//			}
			
			catch (HibernateException HibernateException)
			{
				//session.clear();
				//Hibernate//exception.printStackTrace();
				throw new ItawException("ITAW1014");
			}
			catch(Exception exception)
			{
				//session.clear();
				//exception.printStackTrace();
				throw new ItawException("ITAW1015");
			}
		}

	/**
	 * modify the role
	 * @param role
	 * @return iResult 1 for success and 0 for failure
	 */
	public int modifyRole(RoleDTO role,int iRoleId)throws ItawException
	{
		//iResult stores and returns the success value
		int iResult=0;
		//LoggingService logService=null;
		try
		{
			role.setIRoleId(iRoleId);
			//session=HibernateSessionUtil.currentSession("testfactory");
			//logService=(LoggingService) RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");	
			if(!(checkRoleIdExists(role)))
			{
				System.out.println("RoleDAO : modifyRole "+"CANNOT CREATE ROLE"+role.getStrRoleName());
				iResult = 2;
				System.out.println("RoleDAO : modifyRole "+"ROLE EXISTS"+iResult);
			}
			else
			{
				System.out.println("RoleDAO : ModifyRole "+ "RoleId"+role.getIRoleId()+"RoleName"+role.getStrRoleName()+"Enable Status"+role.getIEnableStatus());
				String strQuery = this.getSQL("UPDATE_ROLE_DETAILS");
                Query query = (Query)this.createQuery(strQuery);
                query.setString(0, role.getStrRoleName()).setString(1, role.getStrRoleDesc()).setInteger(2, role.getIEnableStatus()).setInteger(3, iRoleId).executeUpdate();
                iResult = 1;
			}
		}		
//		catch (ServiceException serviceException)
//		{	
//			//session.clear();
//			service//exception.printStackTrace();
//			throw new ItawException("ITAW1016");
//		}
		catch(ItawException ie)
		{
			//session.clear();
			ie.printStackTrace();
			throw new ItawException("ITAW1019");
		}
		catch (HibernateException HibernateException)
		{
			//session.clear();
			//Hibernate//exception.printStackTrace();
			throw new ItawException("ITAW1017");
		}
//		catch(HibernateHibernateException hbrException)
//		{
//			//session.clear();
//			//exception.printStackTrace();
//			throw new ItawException("ITAW1018");
//		}
		
		catch(Exception exception)
		{
			//session.clear();
			//exception.printStackTrace();
			throw new ItawException("ITAW1020");
		}	
		//session.clear();
		//return the value stored in iResult
		return iResult;
	}
	

	/**
	 * This method retrieves all the role Details
	 * @return list of roles
	 */
	public List listRoleDetails(int iRoleId)throws ItawException
	  {
      //lstRole is used to store the list of Roles
		List lstRole=null;
		//LoggingService log=null;
		try
		{
		 //Retrieve particular Role details from the table
			 strQuery = this
						.getSQL("SELECT_BY_ROLE_ID");
				query = (Query) this.createQuery(strQuery);
				lstRole = (List) query.setInteger(0, iRoleId).list();
		 System.out.println("RoleDAO logger "+"Retrieved Roles:"+lstRole.size());
		}
		/*catch (ServiceException serviceException)
		{	
			//session.clear();
			serviceException.printStackTrace();
			throw new ItawException("ITAW1040");
		}*/
		catch (HibernateException dbexception)
		{	
			//session.clear();
			dbexception.printStackTrace();
			throw new ItawException("ITAW1041");
		}
		catch(Exception exception)
		{		
			//session.clear();
			exception.printStackTrace();
			throw new ItawException("ITAW1042");
		}
		//session.clear();
		//return the value stored in lstRole
		return lstRole;
	  }
	

	/**
	 * This method retrieves all the Privileges
	 * @return list of privileges
	 */
	public List listAllPrivileges()throws ItawException
	  {
      //lstAllPrivileges is used to store the list of privileges
		List lstAllPrivileges=null;
		//LoggingService log=null;
		try
		{
			//Retrieve all the Privileges from the table
			 strQuery = this
						.getSQL("SELECT_PRIVILEGES");
				query = (Query) this.createQuery(strQuery);
				lstAllPrivileges = (List) query.list();
		 
		 System.out.println("RoleDAO-List All Privileges "+"Retrieved Privileges");
		}
		/*catch (ServiceException serviceException)
		{	
			//session.clear();
			serviceException.printStackTrace();
			throw new ItawException("ITAW1043");
		}*/
		catch (HibernateException dbexception)
		{	
			//session.clear();
			dbexception.printStackTrace();
			throw new ItawException("ITAW1044");
		} 
		catch(Exception exception)
		{		
			//session.clear();
			exception.printStackTrace();
			throw new ItawException("ITAW1045");
		}
		//session.clear();
		//return the value stored in lstAllPrivileges
		return lstAllPrivileges;
	  }
	
}
