/* ====================================================================
 *
 * � 2010 Infosys Technologies Limited, Bangalore, India. All rights reserved. 
 * Infosys Test Automation Accelerator * Version: 6.7

 * Except for any open source software components embedded in this Infosys proprietary software program 
 * ("Program"), this Program is protected by copyright laws, international treaties and other pending or existing intellectual
 * property rights in India, the United States 
 * and other countries. Except as expressly permitted, any unauthorized reproduction, storage, transmission in any form 
 * or by any means (including without limitation electronic, mechanical, printing, photocopying, recording or otherwise),
 * or any distribution of this Program, or any portion of it, may result in severe civil and criminal penalties, and will be prosecuted to the maximum extent possible under the law.

 ======================================================================*/
package com.infosys.itaw.user.business.service;

import java.util.List;

import org.springframework.stereotype.Component;

import com.infosys.itaw.user.persistence.dto.SessionDetailsDTO;
import com.infosys.itaw.user.persistence.dto.UserDTO;

import itawexception.ItawException;


@Component
public interface UserService{

	public int fetchUserId(String strUserName) throws ItawException;

	public String fetchDecryptedPassword(int iUserId) throws ItawException;

	public boolean checkUserExists(String UserName) throws ItawException;

	public UserDTO modifyUser(UserDTO UserVO, int iUserId) throws ItawException;

	public int deleteUsers(int iuserID) throws ItawException;

	public List listUsers() throws ItawException;

	public List listUser(int iUserId) throws ItawException;

	/**
	 * creates a user
	 * 
	 * @param arrRoleId
	 * @return iResult - 1 for success and 0 for failure *
	 * @Modification Log: Date Author Description
	 *               ------------------------------------------------------------
	 *               23-Jul-2008 Suja_Pillai Added a new parameter for multiple
	 *               association of roles
	 */

	public int createUser(UserDTO UserVO, int arrRoleId[]) throws ItawException;

	public int addSessionDetails(SessionDetailsDTO sessiondetailsdto) throws ItawException;

	public List fetchRole(int iUserId) throws ItawException;

	public List fetchProject(int iUserId) throws ItawException;

	public List fetchRoles() throws ItawException;

	public int associateNewUserRole(int newRoleIds, int userId) throws ItawException;

	public int disassociateUserRole(int roleId, int userId) throws ItawException;

	public List searchRole(String strRoleName) throws ItawException;

	/**
	 * This method resets the password of a user
	 * 
	 * @param userDTO,iUserId
	 * @return iResult - 1 for success and 0 for failure
	 */
	public int resetPassword(String strPassWord, int iUserId) throws ItawException;
}
