package com.infosys.itaw.user.controller;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.util.UriComponentsBuilder;

import com.google.gson.Gson;
import com.infosys.itaw.user.business.service.UserService;
import com.infosys.itaw.user.persistence.dto.UserDTO;

import itawexception.ItawException;

@RestController
public class UserController {
	@Autowired
	UserService userService;

	// -------------------Get all
	// Users--------------------------------------------------------
	@RequestMapping("/users")
	public String getAllUsers() throws ItawException {

		List listUsers = userService.listUsers();
		String json = new Gson().toJson(listUsers);
		return json;
	}

	// -------------------Get a
	// User--------------------------------------------------------
	@RequestMapping("/users/{id}")
	public String getUserByID(@PathVariable("id") int iUserId) throws ItawException {
		// ResponseEntity<List<User>>
		List listUser = userService.listUser(iUserId);
		String json = new Gson().toJson(listUser);
		return json;
	}

	// -------------------Create a
	// User--------------------------------------------------------

//	@RequestMapping(value = "/user/", method = RequestMethod.POST)
//	public int createUser(@RequestBody UserDTO user, @RequestBody int arrRoleId[]) {
//		int iResult = 0;
//		System.out.println("Creating User " + user.getStrUserName());
//
//		try {
//			if (userService.checkUserExists(user.getStrUserName())) {
//				System.out.println("A User with name " + user.getStrUserName() + " already exist");
//			} else {
//				iResult = userService.createUser(user, arrRoleId);
//			}
//		} catch (ItawException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		// To implement
//		// userService.createUser(user,[1);
//
//		return iResult;
//	}

	@RequestMapping(value = "/user/", method = RequestMethod.GET)
	public int createUser() {
		UserDTO user = new UserDTO();
		user.setStrUserName("chirag12345588");
		user.setStrPassword("abcdecfjk");
		user.setStrEmailId("chirag12345588@infy.com");
		int arrRoleId[] = { 1, 3 };
		int iResult = 0;
		System.out.println("Creating User " + user.getStrUserName());

		try {
			if (userService.checkUserExists(user.getStrUserName())) {
				System.out.println("A User with name " + user.getStrUserName() + "already exist");
			} else {
				iResult = userService.createUser(user, arrRoleId);
			}
		} catch (ItawException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// To implement
		// userService.createUser(user,[1);

		return iResult;
	}

	// -------------------Update a User
	// Details--------------------------------------------------------

	@RequestMapping(value = "/users/", method = RequestMethod.PUT)
	@CrossOrigin(origins = "*", maxAge = 3600, allowedHeaders = { "x-auth-token", "x-requested-with" })
	@ResponseBody
	public String updateUserDetails(@RequestBody UserDTO user) throws ItawException {

		UserDTO editeduserRoleDeatils = new UserDTO();
		int currentUserId = user.getiUserId();
		String userdetails = "";
		try {
			editeduserRoleDeatils = userService.modifyUser(user, currentUserId);
			Gson gson = new Gson();
			userdetails = gson.toJson(editeduserRoleDeatils);

		} catch (ItawException ie) {
			throw ie;
		} catch (Exception e) {
			throw new ItawException("ITAW-ProjectMetrics-020", "UserController", "userDetails", e.getMessage());
		}
		return userdetails;
	}

	// -------------------Update a User
	// Details--------------------------------------------------------
	/*
	 * @RequestMapping(value = "/user/", method = RequestMethod.GET) public
	 * String updateUserDetails() throws ItawException { // @RequestBody UserDTO
	 * user UserDTO user = new UserDTO(); user.setiUserId(4);
	 * user.setStrUserName("chirag07"); user.setStrPassword("xyzs");
	 * user.setStrEmailId("chirag07@infy.com"); UserDTO editeduserRoleDeatils =
	 * new UserDTO(); int currentUserId = user.getiUserId(); String userdetails
	 * = ""; try { editeduserRoleDeatils = userService.modifyUser(user,
	 * currentUserId); Gson gson = new Gson(); userdetails =
	 * gson.toJson(editeduserRoleDeatils);
	 * 
	 * } catch (ItawException ie) { throw ie; } catch (Exception e) { throw new
	 * ItawException("ITAW-ProjectMetrics-020", "UserController", "userDetails",
	 * e.getMessage()); } return userdetails; }
	 */
	@RequestMapping(value = "/user/", method = RequestMethod.DELETE)
	public int deleteUserDetails(@RequestBody int iUserId) throws ItawException {
		// @RequestBody UserDTO user
		int result = 0;
		try {
			result = userService.deleteUsers(iUserId);
		} catch (ItawException ie) {
			throw ie;
		} catch (Exception e) {
			throw new ItawException("ITAW-ProjectMetrics-020", "UserController", "userDetails", e.getMessage());
		}
		return result;
	}

}
