/* ====================================================================
 *
 * � 2010 Infosys Technologies Limited, Bangalore, India. All rights reserved. 
 * Infosys Test Automation Accelerator * Version: 6.7

 * Except for any open source software components embedded in this Infosys proprietary software program 
 * ("Program"), this Program is protected by copyright laws, international treaties and other pending or existing intellectual
 * property rights in India, the United States 
 * and other countries. Except as expressly permitted, any unauthorized reproduction, storage, transmission in any form 
 * or by any means (including without limitation electronic, mechanical, printing, photocopying, recording or otherwise),
 * or any distribution of this Program, or any portion of it, may result in severe civil and criminal penalties, and will be prosecuted to the maximum extent possible under the law.

 ======================================================================*/
/*****************************************************************************
 *   Revision History
 *   ------------------
 *   Name         :  UserDAO.java
 *   Author       :  Neha_mittal03
 *   Date         :  20/August/2007
 *   Description  :  This class represents Data Access object for Users
 *
 *   $Log		  :  UserDAO.java$
 *   Modification Log:
 *   * Date                 Author                     Description
 *   * ------------------------------------------------------------
 *	 * 20-Aug-2007          Neha_mittal03              Created
 *	 * 16-Jun-2008 			Abraham_Mammen			   Created function addSessionDetails for performance tuning
 *	 * 16-Jun-2008          Abraham_Mammen             Query added to delete from Session_details table in deleteUsers function.
 *	 * 31-Jul-2008			Shilpa_Nanoo			   searchUser,searchRole-Query changed to enable blank search and to arrange retrived result in alphabetic order
 *	 #
 *****************************************************************************/
package com.infosys.itaw.user.persistence.dao;

/* Importing java classes */
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.springframework.stereotype.Repository;

/* Importing ITAW files */
//import com.infosys.itaw.role.persistence.dto.RoleDTO;
import com.infosys.itaw.user.persistence.dto.SessionDetailsDTO;
import com.infosys.itaw.user.persistence.dto.UserDTO;
import com.infosys.itaw.user.persistence.dto.UserRoleDTO;
import com.infosys.itaw.util.GenericHibernateDAO;

/* Importing radien classes 
import com.infosys.j2ee.core.ServiceException;
import com.infosys.j2ee.core.impl.RadienServiceLocator;
import com.infosys.j2ee.infrastructure.service.logging.LoggingService;
import com.infosys.j2ee.subframework.persistence.dao.DBException;
import com.infosys.j2ee.subframework.persistence.dao.impl.GenericHibernateDAO;
import com.infosys.j2ee.subframework.persistence.dao.impl.HibernateSessionUtil;
import com.licensing.DecryptTool;*/

import itawexception.ItawException;

/**
 * This is the DAO class for Manage User Module.
 * 
 * @author Neha_mittal03
 */
@Repository
public class UserDAO extends GenericHibernateDAO {

	public UserDAO() throws ItawException {
		try {
			// logService = (LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
		} // catch (ServiceException e) {
			// throw new ItawException("ITAW11022");
			// }
		catch (Exception e) {
			// System.out.println("Service initialization error");
			throw new ItawException("ITAW11023");
		}
	}

	/**
	 * Creates a user
	 * 
	 * @param user
	 * @return iResult 1 for success and 0 for failure
	 * @Modification log: Added functionality to return userid of user
	 */
	public int createUser(UserDTO user) throws ItawException {
		// LoggingService logService=null;

		/*
		 * DecryptTool decryptTool=new DecryptTool(); String
		 * licensefile="c:/License/licensefile.xml"; String
		 * destination="c:/License/license2.xml"; int iNoOfUser; int
		 * iTotalUsers;
		 */

		// iResult is used to store and return the success value
		int iResult = 0;

		try {

			// creating an instance of logging service

			/*
			 * BBN logService.info(" ITAW-UserDAO", "hi userdao create user");
			 */

			/*
			 * Code for verifying the number of users allowed in the license
			 * file.
			 */
			// Decrypting the license file
			/*
			 * decryptTool.decrypt(licensefile,destination);
			 * 
			 * //retrieving the number of users from license file
			 * DocumentBuilderFactory docFactory =
			 * DocumentBuilderFactory.newInstance(); DocumentBuilder docBuilder
			 * = docFactory.newDocumentBuilder(); Document doc =
			 * docBuilder.parse(destination); NodeList nodeList =
			 * doc.getElementsByTagName("NumberOfUsers"); Element node0 =
			 * (Element)nodeList.item(0); Attr attrNode =
			 * node0.getAttributeNode("value");
			 * iNoOfUser=Integer.parseInt(attrNode.getValue());
			 * 
			 * List lstResult=(List)executeHQLQuery("from UserDTO");
			 * iTotalUsers=lstResult.size(); if(iTotalUsers<iNoOfUser) {
			 */
			// Insert the user object to database
			Object usercreated = create(user);
			System.out.println("Create User DAO:" + "Created the user");
			// Integer id =
			// (Integer)HibernateSessionUtil.currentSession("testfactory").getIdentifier(user);
			// iResult = id.intValue();
			iResult = Integer.parseInt(usercreated.toString());
			// iResult=1;
			/*
			 * } else { iResult=0; }
			 */
		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0501");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0502");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0503");
		}
		return (iResult);
	}

	/***************************************************************************
	 * Add userid to session details.
	 * 
	 * @param sessiondetails
	 * @return iResult 1 for success and 0 for failure
	 * @Modification Log: Date Author Description
	 *               ------------------------------------------------------------
	 *               16-Jun-2008 Abraham_Mammen Created function for performance
	 *               tuning
	 **************************************************************************/

	public int addSessionDetails(SessionDetailsDTO sessiondetails) throws ItawException {
		// LoggingService logService=null;

		/*
		 * DecryptTool decryptTool=new DecryptTool(); String
		 * licensefile="c:/License/licensefile.xml"; String
		 * destination="c:/License/license2.xml"; int iNoOfUser; int
		 * iTotalUsers;
		 */

		// iResult is used to store and return the success value
		int iResult = 0;

		try {

			// creating an instance of logging service
			// logService=(LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
			System.out.println(" ITAW-UserDAO" + "hi userdao add session details");

			/*
			 * Code for verifying the number of users allowed in the license
			 * file.
			 */
			// Decrypting the license file
			/*
			 * decryptTool.decrypt(licensefile,destination);
			 * 
			 * //retrieving the number of users from license file
			 * DocumentBuilderFactory docFactory =
			 * DocumentBuilderFactory.newInstance(); DocumentBuilder docBuilder
			 * = docFactory.newDocumentBuilder(); Document doc =
			 * docBuilder.parse(destination); NodeList nodeList =
			 * doc.getElementsByTagName("NumberOfUsers"); Element node0 =
			 * (Element)nodeList.item(0); Attr attrNode =
			 * node0.getAttributeNode("value");
			 * iNoOfUser=Integer.parseInt(attrNode.getValue());
			 * 
			 * List lstResult=(List)executeHQLQuery("from UserDTO");
			 * iTotalUsers=lstResult.size(); if(iTotalUsers<iNoOfUser) {
			 */
			// Insert the user object to database
			create(sessiondetails);
			iResult = 1;
			/*
			 * } else { iResult=0; }
			 */
		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0501");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW12609");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW12610");
		}
		return (iResult);
	}

	/**
	 * checks whether user exists
	 * 
	 * @param strUserName
	 * @return True if exists
	 */
	public boolean checkUserExists(String strUserName) throws ItawException {

		// LoggingService logService=null;
		// System.out.println("inside DAO");
		String strQuery = null;
		Query query = null;
		ArrayList user = new ArrayList();
		try {
			// creating an instance of logging service
			// logService=(LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
			strQuery = this.getSQL("SELECT_BY_NAME");
			query = this.createQuery(strQuery);
			// Retrieve all the rows with name as strUserName

			query.setString(0, strUserName);
			user = (ArrayList) query.list();
			// checks whether any row exists in databse with the name
			// strUserName
			if (user.size() == 0) {
				System.out.println(" ITAW-UserDAO" + "The User name does not exists");
				return false;
			} else {
				System.out.println(" ITAW-UserDAO" + "The User name already exists");
				return true;
			}
		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0504");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0505");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0506");
		}
	}

	// BBN
	/**
	 * retrieves all users
	 * 
	 * @param NIL
	 * @return list of all users
	 */
	public List listUsers() throws ItawException {

		// ArrayList result = new ArrayList();
		// lstUser is used to store the list of users
		List lstUser = null;
		String strQuery;
		Query query;

		try {

			strQuery = this.getSQL("SELECT_ALL_USERS");
			query = (Query) this.createQuery(strQuery);
			lstUser = (List) query.list();
			// BBN
			System.out.println(" ITAW-UserDAO" + "retrieved the users");

		} catch (HibernateException e) {
			e.printStackTrace();
			throw new ItawException("ITAW0508");
		} catch (Exception e) {
			e.printStackTrace();
			throw new ItawException("ITAW0509");
		}
		return lstUser;
	}

	public String fetchUserPassword(int userId) throws ItawException {
		String strQuery = null;
		Query query = null;
		ArrayList users = new ArrayList();
		try {
			// Retrieve all the rows with name as strUserName
			strQuery = this.getSQL("SELECT_BY_ID");
			// Executing the query.
			query = (Query) this.createQuery(strQuery);
			// Retrieve all the rows with name = strUserName
			users = (ArrayList) query.setInteger(0, userId).list();
			// checks whether any row exists in database with the name
			// strUserName
			if (users.size() == 0) {
				// logService.info(" ITAW-UserDAO", "The User name does not
				// exists");
				System.out.println(" ITAW-UserDAO" + "The User name does not exists");
			} else {
				UserDTO user = (UserDTO) users.get(0);
				return user.getStrPassword();
			}
		} catch (HibernateException e) {
			throw new ItawException("ITAW0505");
		} catch (Exception exception) {
			throw new ItawException("ITAW0506");
		}
		return null;
	}

	public int fetchUserID(String strUserName) throws ItawException {
		String strQuery = null;
		Query query = null;
		ArrayList users = new ArrayList();
		try {
			// Retrieve all the rows with name as strUserName
			// BBN
			// ArrayList users = (ArrayList) executeHQLQuery("from UserDTO where
			// strUserName='" + strUserName + "'");
			strQuery = this.getSQL("SELECT_BY_NAME");
			// Executing the query.
			query = (Query) this.createQuery(strQuery);
			// Retrieve all the rows with name = strUserName
			users = (ArrayList) query.setString(0, strUserName).list();
			//
			// checks whether any row exists in database with the name
			// strUserName
			if (users.size() == 0) {
				// logService.info(" ITAW-UserDAO", "The User name does not
				// exists");
				System.out.println(" ITAW-UserDAO" + "The User name does not exists");
			} else {
				UserDTO user = (UserDTO) users.get(0);
				return user.getiUserId();
			}
		} catch (HibernateException e) {
			throw new ItawException("ITAW0505");
		} catch (Exception exception) {
			throw new ItawException("ITAW0506");
		}
		return -1;
	}

	/***************************************************************************
	 * This method delete the user corresponding to a particular user id.
	 * 
	 * @param iUserId
	 * @return iResult - 1 for success and 0 for failure
	 * @Modification Log: Date Author Description
	 *               ------------------------------------------------------------
	 *               12-Jan-2007 Created 16-Jun-2008 Abraham_Mammen Query added
	 *               to delete from Session_details table
	 **************************************************************************/

	public int deleteUsers(int iUserId) throws ItawException {
		int iResult = 0;
		// LoggingService logService=null;
		try {
			// creating an instance of logging service
			// logService=(LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");

			// Deleting the user with given ID
			// String sqlQuery="delete from Users_Master where
			// usr_id='"+iUserId+"'";
			// executeSQLQuery(sqlQuery,"aa");
			// iResult=1;
			// ToImplenent
			// List associate = (List) executeHQLQuery("from ProjectUsersDTO
			// where IUserId=" + iUserId);
			// if(associate.size()==0)
			// {
			// String query1 = this.getSQL("DELETE_PROJECT_USER_DETAILS");
			// Query selQuery = (Query) this.createQuery(query1);
			// selQuery.executeUpdate();

			String query2 = this.getSQL("DELETE_USER_ROLE_DETAILS");

			Query selQuery1 = (Query) this.createQuery(query2);
			selQuery1.setInteger(0, iUserId);
			selQuery1.executeUpdate();

			// code added for performance tuning
			// String query3 =this.getSQL("DELETE_SESSION_DETAILS");
			// Query selQuery2 = (Query) this.createQuery(query3);
			// selQuery2.executeUpdate();

			String query4 = this.getSQL("DELETE_USER_DETAILS");
			Query queryDelete = (Query) this.createQuery(query4);
			// Retrieve all the rows with name = strUserName

			// UserDTO user = new UserDTO();
			// creating a new user object and setting the Id field
			// user.setiUserId(iUserId);

			// deleting the object from table
			// delete(user);
			iResult = queryDelete.setInteger(0, iUserId).executeUpdate();
			// iResult = 1;
			// }
			// else
			// {
			// iResult=0;
			// }

		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0510");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0511");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0512");
		}

		return iResult;
	}

	/**
	 * modify the user
	 * 
	 * @param UserVO
	 *            - User
	 * @return iResult - 1 for success and 0 for failure
	 */

	/**
	 * modify the user
	 * 
	 * @param UserVO
	 *            - User
	 * @return iResult - 1 for success and 0 for failure
	 */

	public int modifyUser(UserDTO user, int iUserId) throws ItawException {
		String strQuery = null;
		String strQueryUpdate = null;
		Query query = null;
		Query queryUpdate = null;
		// iResult stores and returns the success value
		int iResult = 0;
		String strUserName = null;

		try {

			strUserName = user.getStrUserName();

			// Collection colUser = (Collection) executeHQLQuery("from UserDTO
			// where strUserName='" + strUserName + "' and IUserId!=" +
			// iUserId);
			strQuery = this.getSQL("CHECK_FOR_SAME_USERNAME_ON_UPDATE");
			strQueryUpdate = this.getSQL("UPDATE_USER_DETAILS");
			;
			// Executing the query.
			query = (Query) this.createQuery(strQuery);
			queryUpdate = (Query) this.createQuery(strQueryUpdate);
			// Retrieve all the rows with name = strUserName
			Collection colUser = (Collection) query.setString(0, strUserName).setInteger(1, iUserId).list();
			if (colUser.size() == 0) {
				// updating the object
				// update(user);
				iResult = queryUpdate.setString(0, user.getStrUserName()).setString(1, user.getStrEmailId())
						.setInteger(2, iUserId).executeUpdate();
				// setting the return value as 1 for success
				// iResult = 1;
			} else {
				iResult = 0;
			}

		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0513");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0514");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0515");
		}

		return iResult;
	}

	// public List listUser(int iUserId) throws ItawException {
	public ArrayList getUserByUserID(int iUserId) throws ItawException {
		// LoggingService logService=null;
		String strQuery = null;
		Query query = null;
		ArrayList user = new ArrayList();
		// lstproject is used to store the list of Projects

		try {
			// logService=(LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
			strQuery = this.getSQL("SELECT_BY_ID");
			query = (Query) this.createQuery(strQuery);
			// Retrieve all the Projects from tableSELECT_BY_ID
			user = (ArrayList) query.setInteger(0, iUserId).list();
			// executeHQLQuery("from UserDTO where IUserId='" + iUserId + "'");

		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0516");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0517");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0518");
		}
		// returning the result
		return user;
	}

	/**
	 * retrieves the role corresponding to a particular userid
	 * 
	 * @parami UserId
	 * @return List of roles
	 */

	public List fetchRole(int iUserId) throws ItawException {
		List roles = null;
		// LoggingService log = null;
		try {
			// creating an instance of logging service
			// log=(LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");

			System.out.println(" ITAW-UserDAO" + "Inside DAO...about to execute query.");
			// Fetches the role details corresponding to the given userId
			// ToImplement
			// roles = (List) executeHQLQuery("from RoleDTO where IRoleId in
			// (select IRoleId from UserRoleDTO where IUserId =" + iUserId +
			// ")");

			System.out.println(" ITAW-UserDAO" + "Fetches a particular role corresponding to the given userId in DAO.");
			// log.info(" ITAW-UserDAO","Roles: "+roles.size());
		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0519");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0520");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0521");
		}
		return roles;
	}

	// public List fetchProject(int iUserId) throws ItawException {
	public List fetchProjectMappedToUserByUserID(int iUserId) throws ItawException {
		List project = null;
		String strQuery = null;
		Query query = null;
		try {

			/*
			 * BBN logService.info(" ITAW-UserDAO",
			 * "Inside DAO...about to execute query.");
			 */
			// Fetches the role details corresponding to the given userId
			/*
			 * BBN project = (List)
			 * executeHQLQuery("from ProjectDTO where IProjectId in (select IProjectId from ProjectUsersDTO where IUserId ="
			 * + iUserId + ")");
			 */
			strQuery = this.getSQL("SELECT_BY_NAME");
			// Executing the query.
			query = (Query) this.createQuery(strQuery);
			// ToImplement
			// project = (List) executeHQLQuery("from ProjectDTO where
			// IProjectId in (select IProjectId from ProjectUsersDTO where
			// IUserId =" + iUserId + ")");
			/*
			 * BBN logService.info(" ITAW-UserDAO",
			 * "Fetches a particular role corresponding to the given userId in DAO."
			 * );
			 */

		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0522");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0523");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0524");
		}
		return project;
	}

	/**
	 * retrieve all the roles
	 * 
	 * @parami NIL
	 * @return List of roles
	 */

	public List fetchRoles() throws ItawException {
		// LoggingService logService=null;

		// lstRole is used to store the list of Roles
		List lstRole = null;
		try {
			// creating an instance of logging service
			// logService=(LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");

			// Retrieve all the Roles from table
			// To Implement
			// lstRole = (List) executeHQLQuery("from RoleDTO where
			// IEnableStatus=1");

			// logService.info(" ITAW-UserDAO","retrieved the
			// roles:"+lstRole.size());
			// RoleDTO role=(RoleDTO)lstRole.get(0);
			// logService.info(" ITAW-UserDAO","retrieved the
			// roles:"+role.getIRoleId()+" "+role.getStrRoleName());

		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0525");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0526");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0527");
		}
		return lstRole;
	}

	/**
	 * @param iUserId
	 *            the user id
	 * @param iRoleId
	 *            the role id associate roles to user
	 * @return iResult 1 for success and 0 for failure
	 */

	public int associateNewUserRole(int iRoleId, int iUserId) throws ItawException {
		int iResult = 0;
		// LoggingService logService=null;
		try {
			// logService=(LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
			UserRoleDTO userRole = new UserRoleDTO();
			userRole.setiRoleId(iRoleId);
			userRole.setiUserId(iUserId);
			
			// Executing the query.
			 create(userRole);
			System.out.println("AssociateUserRole-DAO" + "Roles associated");
			System.out.println("AssociateUserRole-DAO" + "Values inserted into database");
			iResult = 1;
		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0528");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0529");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0530");
		}
		return iResult;
	}

	/**
	 * @param iUserId
	 *            the user id
	 * @param iRoleId
	 *            the role id disassociate roles to user
	 * @return iResult 1 for success and 0 for failure
	 */
	public int disassociateUserRole(int iRoleId, int iUserId) throws ItawException {
		int iResult = 0;
		// LoggingService logService=null;
		try {
			// logService=(LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
			UserRoleDTO userRole = new UserRoleDTO();
			userRole.setiRoleId(iRoleId);
			userRole.setiUserId(iUserId);
			delete(userRole);
			System.out.println("DisassociateUserRole" + "Roles deleted");
			System.out.println("DisassociateUserRoles" + "Values deleted from database");
			iResult = 1;
		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0531");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0532");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0533");
		}
		return iResult;
	}

	/***************************************************************************
	 * search for the Role
	 * 
	 * @param strRoleName
	 *            string for searching
	 * @return List of Roles
	 * @Modification Log Date Author Description
	 *               ------------------------------------------------------------
	 *               31-Jul-2008 Shilpa_Nanoo Query changed to enable blank
	 *               search and to arrange retrived result in alphabetic order
	 **************************************************************************/

	public List searchRole(String strRoleName) throws ItawException {

		// LoggingService logService=null;
		List lstRole = null;
		try {
			// logService.info("logger1","platform id: "+iPlatformId);
			// logService=(LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");
			// ToImplement
			// lstRole = (List) executeHQLQuery("from RoleDTO where
			// IEnableStatus=1 and strRoleName like'" + strRoleName + "%' order
			// by strRoleName");

			System.out.println("UserDAO : searchRoles" + "Retrieved Roles");

		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0588");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0589");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0590");
		}
		return lstRole;
	}

	/***************************************************************************
	 * search for the User
	 * 
	 * @param strUserName
	 *            string for searching
	 * @return user List of Users
	 * @Modification Log Date Author Description
	 *               ------------------------------------------------------------
	 *               31-Jul-2008 Shilpa_Nanoo Query changed to enable blank
	 *               search and to arrange retrived result in alphabetic order
	 **************************************************************************/
	public List searchUser(String strSearchString) throws ItawException {

		List lstUser = null;
		// LoggingService logService=null;

		try { // Session
				// session=HibernateSessionUtil.currentSession("testfactory");
				// logService=(LoggingService)
				// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");

			// Retrieving the application platform which starts with given
			// string
			// ToImplement
			// lstUser = (List) executeHQLQuery("from UserDTO where strUserName
			// like'" + strSearchString + "%' order by strUserName");
			// getTransaction().commit();
			// session.clear();
		} catch (HibernateException e) {
			// dbexception.printStackTrace();
			throw new ItawException("ITAW0583");
		}
		// catch (ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		//
		// throw new ITAWException("ITAW0584");
		// }
		catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0585");
		}

		return lstUser;
	}

	public UserDTO getUser(String strSearchString) throws ItawException {
		UserDTO userDTO = null;
		List lstUser = null;
		try {
			// ToImplement
			// List lstUser = (List) executeHQLQuery("from UserDTO where
			// strUserName ='" + strSearchString + "'");
			if (lstUser == null || lstUser.size() != 1 || lstUser.get(0) == null)
				throw new Exception("Invalid UserName");

			userDTO = (UserDTO) lstUser.get(0);
		} catch (HibernateException e) {
			throw new ItawException("ITAW0583");
		} catch (Exception exception) {
			throw new ItawException("ITAW0585");
		}
		return userDTO;
	}

	/**
	 * This method resets the password of a user
	 * 
	 * @param userDTO,iUserId
	 * @return iResult - 1 for success and 0 for failure
	 */
	public int resetPassword(String strPassWord, int iUserId) throws ItawException {
		int iResult = 0;
		String strOldPassword;
		ArrayList colUser = new ArrayList();
		// LoggingService logService=null;
		try {
			// creating an instance of logging service
			// logService=(LoggingService)
			// RadienServiceLocator.getInstance().getService("default-Log4jLoggingService");

			// ToImplement
			// ArrayList colUser = (ArrayList) executeHQLQuery("from UserDTO
			// where IUserId=" + iUserId);
			UserDTO user = (UserDTO) colUser.get(0);
			strOldPassword = user.getStrPassword();
			if (strPassWord.equals(strOldPassword) == true) {
				iResult = 2;
			} else {
				user.setStrPassword(strPassWord);
				// updating the password
				update(user);
				iResult = 1;
			}
		}
		// catch(ServiceException serviceException)
		// {
		// serviceException.printStackTrace();
		// throw new ITAWException("ITAW0591");
		// }
		catch (HibernateException e) {
			// dbException.printStackTrace();
			throw new ItawException("ITAW0592");
		} catch (Exception exception) {
			// exception.printStackTrace();
			throw new ItawException("ITAW0593");
		}

		return iResult;
	}

}
